// ConnectedComponent.h: interface for the ConnectedComponent class.
//
//////////////////////////////////////////////////////////////////////

#ifndef _CONNECTEDCOMPONENT_H_
#define _CONNECTEDCOMPONENT_H_

#include <list>
#include <vector>
#include "Node.h"
#include "GreyScale8Image.h"
#include "CRect.h"

using namespace std;

template <class T>
class List : public list<T>, public Object {
  

};

class ConnectedComponent : public Node
{
  
 public:
  
  ConnectedComponent(string nodeName, ParameterSet params);
  virtual ObjectRef getOutput(int output_id, int count); 
  virtual ~ConnectedComponent();
  const int MAXIMUM_RECURSION_LEVEL;
  
 private:
  
  int m_IMAGE_ID;
  ObjectRef m_output;
  List<CRect> *m_RectList;
  GreyScale8Image *m_image;
  void get_components();
  void get_components_recursive (CRect &rect, int x,int y);
  void MergeRectangle(CRect &rect);
  int m_xSize;
  int m_ySize;
  int m_rlevel;
  int m_ySampling;
  int m_xSampling;
  
  // Default constructor, should not be used
  ConnectedComponent() {throw(GeneralException("ConnectedComponent default constructor should not be called",__FILE__,__LINE__));}
  
};

#endif
